# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arduino_daq/AnalogReading.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AnalogReading(genpy.Message):
  _md5sum = "65f333d2a48c74e3b037f8cc0355c7fd"
  _type = "arduino_daq/AnalogReading"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message holds the ADC output for one sampling period
# for arduino_daq. Note that all 8 channels are always reported despite
# the actual number of active channels. E.g. if only one ADC channel is
# active, the actual reading will be in adc_data[0].

uint32    timestamp_ms   # Timestap of the microcontroller, in millisecs since boot
uint16[8] adc_data       # ADC raw reading. Multiply by VOLT_REF/1023 to obtain volts
"""
  __slots__ = ['timestamp_ms','adc_data']
  _slot_types = ['uint32','uint16[8]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp_ms,adc_data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AnalogReading, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp_ms is None:
        self.timestamp_ms = 0
      if self.adc_data is None:
        self.adc_data = [0] * 8
    else:
      self.timestamp_ms = 0
      self.adc_data = [0] * 8

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.timestamp_ms
      buff.write(_get_struct_I().pack(_x))
      buff.write(_get_struct_8H().pack(*self.adc_data))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (self.timestamp_ms,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 16
      self.adc_data = _get_struct_8H().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.timestamp_ms
      buff.write(_get_struct_I().pack(_x))
      buff.write(self.adc_data.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (self.timestamp_ms,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 16
      self.adc_data = numpy.frombuffer(str[start:end], dtype=numpy.uint16, count=8)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_8H = None
def _get_struct_8H():
    global _struct_8H
    if _struct_8H is None:
        _struct_8H = struct.Struct("<8H")
    return _struct_8H
