# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from arduino_daq/EncoderAbsReading.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class EncoderAbsReading(genpy.Message):
  _md5sum = "74eeaa01bf3abcca0b6070228ead1d14"
  _type = "arduino_daq/EncoderAbsReading"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message holds the readings from absolute encoder for arduino_daq.

uint32    timestamp_ms   # Timestap of the microcontroller, in millisecs since boot
int32     encoder_value  # Signed position of the encoder sensor (in ticks, or encoder periods. x1, not x4, counts)
int8      encoder_status # Checkout datasheet
"""
  __slots__ = ['timestamp_ms','encoder_value','encoder_status']
  _slot_types = ['uint32','int32','int8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp_ms,encoder_value,encoder_status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EncoderAbsReading, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.timestamp_ms is None:
        self.timestamp_ms = 0
      if self.encoder_value is None:
        self.encoder_value = 0
      if self.encoder_status is None:
        self.encoder_status = 0
    else:
      self.timestamp_ms = 0
      self.encoder_value = 0
      self.encoder_status = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_Iib().pack(_x.timestamp_ms, _x.encoder_value, _x.encoder_status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.timestamp_ms, _x.encoder_value, _x.encoder_status,) = _get_struct_Iib().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_Iib().pack(_x.timestamp_ms, _x.encoder_value, _x.encoder_status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.timestamp_ms, _x.encoder_value, _x.encoder_status,) = _get_struct_Iib().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_Iib = None
def _get_struct_Iib():
    global _struct_Iib
    if _struct_Iib is None:
        _struct_Iib = struct.Struct("<Iib")
    return _struct_Iib
