// Auto-generated. Do not edit!

// (in-package arduino_daq.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class AnalogReading {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp_ms = null;
      this.adc_data = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp_ms')) {
        this.timestamp_ms = initObj.timestamp_ms
      }
      else {
        this.timestamp_ms = 0;
      }
      if (initObj.hasOwnProperty('adc_data')) {
        this.adc_data = initObj.adc_data
      }
      else {
        this.adc_data = new Array(8).fill(0);
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AnalogReading
    // Serialize message field [timestamp_ms]
    bufferOffset = _serializer.uint32(obj.timestamp_ms, buffer, bufferOffset);
    // Check that the constant length array field [adc_data] has the right length
    if (obj.adc_data.length !== 8) {
      throw new Error('Unable to serialize array field adc_data - length must be 8')
    }
    // Serialize message field [adc_data]
    bufferOffset = _arraySerializer.uint16(obj.adc_data, buffer, bufferOffset, 8);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AnalogReading
    let len;
    let data = new AnalogReading(null);
    // Deserialize message field [timestamp_ms]
    data.timestamp_ms = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [adc_data]
    data.adc_data = _arrayDeserializer.uint16(buffer, bufferOffset, 8)
    return data;
  }

  static getMessageSize(object) {
    return 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arduino_daq/AnalogReading';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '65f333d2a48c74e3b037f8cc0355c7fd';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message holds the ADC output for one sampling period
    # for arduino_daq. Note that all 8 channels are always reported despite
    # the actual number of active channels. E.g. if only one ADC channel is
    # active, the actual reading will be in adc_data[0].
    
    uint32    timestamp_ms   # Timestap of the microcontroller, in millisecs since boot
    uint16[8] adc_data       # ADC raw reading. Multiply by VOLT_REF/1023 to obtain volts
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AnalogReading(null);
    if (msg.timestamp_ms !== undefined) {
      resolved.timestamp_ms = msg.timestamp_ms;
    }
    else {
      resolved.timestamp_ms = 0
    }

    if (msg.adc_data !== undefined) {
      resolved.adc_data = msg.adc_data;
    }
    else {
      resolved.adc_data = new Array(8).fill(0)
    }

    return resolved;
    }
};

module.exports = AnalogReading;
