// Auto-generated. Do not edit!

// (in-package arduino_daq.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class EncodersReading {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp_ms = null;
      this.period_ms = null;
      this.encoder_values = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp_ms')) {
        this.timestamp_ms = initObj.timestamp_ms
      }
      else {
        this.timestamp_ms = 0;
      }
      if (initObj.hasOwnProperty('period_ms')) {
        this.period_ms = initObj.period_ms
      }
      else {
        this.period_ms = 0;
      }
      if (initObj.hasOwnProperty('encoder_values')) {
        this.encoder_values = initObj.encoder_values
      }
      else {
        this.encoder_values = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type EncodersReading
    // Serialize message field [timestamp_ms]
    bufferOffset = _serializer.uint32(obj.timestamp_ms, buffer, bufferOffset);
    // Serialize message field [period_ms]
    bufferOffset = _serializer.uint32(obj.period_ms, buffer, bufferOffset);
    // Serialize message field [encoder_values]
    bufferOffset = _arraySerializer.int32(obj.encoder_values, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type EncodersReading
    let len;
    let data = new EncodersReading(null);
    // Deserialize message field [timestamp_ms]
    data.timestamp_ms = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [period_ms]
    data.period_ms = _deserializer.uint32(buffer, bufferOffset);
    // Deserialize message field [encoder_values]
    data.encoder_values = _arrayDeserializer.int32(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 4 * object.encoder_values.length;
    return length + 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'arduino_daq/EncodersReading';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '9ad5bff481c287ab00a1df4fc351c68b';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message holds the readings from (software-based) quadrature encoder
    # decoders for arduino_daq.
    
    uint32    timestamp_ms   # Timestap of the microcontroller, in millisecs since boot
    uint32    period_ms      # Time, in milliseconds, between consecutive messages. Can be used to estimate velocity
    int32[]   encoder_values # Signed position of each encoder channel (in ticks, or encoder periods. x1, not x4, counts)
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new EncodersReading(null);
    if (msg.timestamp_ms !== undefined) {
      resolved.timestamp_ms = msg.timestamp_ms;
    }
    else {
      resolved.timestamp_ms = 0
    }

    if (msg.period_ms !== undefined) {
      resolved.period_ms = msg.period_ms;
    }
    else {
      resolved.period_ms = 0
    }

    if (msg.encoder_values !== undefined) {
      resolved.encoder_values = msg.encoder_values;
    }
    else {
      resolved.encoder_values = []
    }

    return resolved;
    }
};

module.exports = EncodersReading;
